xfs
[Top] [All Lists]

[PATCH 3/4] renameat2 syscall: check noreplace rename

To: xfs@xxxxxxxxxxx
Subject: [PATCH 3/4] renameat2 syscall: check noreplace rename
From: Miklos Szeredi <miklos@xxxxxxxxxx>
Date: Fri, 11 Apr 2014 17:51:56 +0200
Cc: Miklos Szeredi <mszeredi@xxxxxxx>
Delivered-to: xfs@xxxxxxxxxxx
Dkim-signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=szeredi.hu; s=google; h=from:to:cc:subject:date:message-id:in-reply-to:references; bh=RsWkQpQtqt/U4eRc8El0+MabUsT/s3YEgGbGsy7xNCg=; b=podp2KFF/lUA9pTG/QoZYGG06lj10DedCvr4IdFUuUKNtZHfQ5WVwli3yYntf+c2xN 3DozxRrQCzNHDZe+CKxfh+DEyv3ohDcinp7v/1pBNHB5Eu3HV7iSqGwgcFzfqEdRwBQY dgQJsZLrQL8dxkdD4EhRThHOJYF2EIF7CUA/E=
In-reply-to: <1397231517-4641-1-git-send-email-miklos@xxxxxxxxxx>
References: <1397231517-4641-1-git-send-email-miklos@xxxxxxxxxx>
From: Miklos Szeredi <mszeredi@xxxxxxx>

Check with RENAME_NOREPLACE flag.  This flag indicates that the rename must
fail if the target of the rename exists.

Signed-off-by: Miklos Szeredi <mszeredi@xxxxxxx>
---
 tests/generic/324     | 64 +++++++++++++++++++++++++++++++++++++++++++++++++++
 tests/generic/324.out | 51 ++++++++++++++++++++++++++++++++++++++++
 tests/generic/group   |  1 +
 3 files changed, 116 insertions(+)
 create mode 100755 tests/generic/324
 create mode 100644 tests/generic/324.out

diff --git a/tests/generic/324 b/tests/generic/324
new file mode 100755
index 0000000..7b45ca8
--- /dev/null
+++ b/tests/generic/324
@@ -0,0 +1,64 @@
+#! /bin/bash
+# FS QA Test No. generic/324
+#
+# Check renameat2 syscall with RENAME_NOREPLACE flag
+#
+#-----------------------------------------------------------------------
+# Copyright (c) 2014 Miklos Szeredi.  All Rights Reserved.
+#
+# This program is free software; you can redistribute it and/or
+# modify it under the terms of the GNU General Public License as
+# published by the Free Software Foundation.
+#
+# This program is distributed in the hope that it would be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write the Free Software Foundation,
+# Inc.,  51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
+#-----------------------------------------------------------------------
+#
+
+seq=`basename $0`
+seqres=$RESULT_DIR/$seq
+echo "QA output created by $seq"
+
+here=`pwd`
+tmp=/tmp/$$
+status=1       # failure is the default!
+trap "_cleanup; exit \$status" 0 1 2 3 15
+
+_cleanup()
+{
+    cd /
+    rm -f $tmp.*
+}
+
+# get standard environment, filters and checks
+. ./common/rc
+. ./common/renameat2
+
+_supported_fs generic
+_supported_os Linux
+
+_requires_renameat2
+
+rename_dir=$TEST_DIR/$$
+mkdir $rename_dir
+touch $rename_dir/foo
+if ! src/renameat2 -t -n $rename_dir/foo $rename_dir/bar; then
+    rm -f $rename_dir/foo $rename_dir/bar; rmdir $rename_dir
+    _notrun "fs doesn't support RENAME_NOREPLACE"
+fi
+rm -f $rename_dir/foo $rename_dir/bar
+
+# real QA test starts here
+
+_rename_tests $rename_dir -n
+rmdir $rename_dir
+
+# success, all done
+status=0
+exit
diff --git a/tests/generic/324.out b/tests/generic/324.out
new file mode 100644
index 0000000..fff5547
--- /dev/null
+++ b/tests/generic/324.out
@@ -0,0 +1,51 @@
+QA output created by 324
+samedir  none/none -> No such file or directory
+samedir  none/regu -> No such file or directory
+samedir  none/symb -> No such file or directory
+samedir  none/dire -> No such file or directory
+samedir  none/tree -> No such file or directory
+samedir  regu/none -> none/regu.
+samedir  regu/regu -> File exists
+samedir  regu/symb -> File exists
+samedir  regu/dire -> File exists
+samedir  regu/tree -> File exists
+samedir  symb/none -> none/symb.
+samedir  symb/regu -> File exists
+samedir  symb/symb -> File exists
+samedir  symb/dire -> File exists
+samedir  symb/tree -> File exists
+samedir  dire/none -> none/dire.
+samedir  dire/regu -> File exists
+samedir  dire/symb -> File exists
+samedir  dire/dire -> File exists
+samedir  dire/tree -> File exists
+samedir  tree/none -> none/tree.
+samedir  tree/regu -> File exists
+samedir  tree/symb -> File exists
+samedir  tree/dire -> File exists
+samedir  tree/tree -> File exists
+crossdir none/none -> No such file or directory
+crossdir none/regu -> No such file or directory
+crossdir none/symb -> No such file or directory
+crossdir none/dire -> No such file or directory
+crossdir none/tree -> No such file or directory
+crossdir regu/none -> none/regu.
+crossdir regu/regu -> File exists
+crossdir regu/symb -> File exists
+crossdir regu/dire -> File exists
+crossdir regu/tree -> File exists
+crossdir symb/none -> none/symb.
+crossdir symb/regu -> File exists
+crossdir symb/symb -> File exists
+crossdir symb/dire -> File exists
+crossdir symb/tree -> File exists
+crossdir dire/none -> none/dire.
+crossdir dire/regu -> File exists
+crossdir dire/symb -> File exists
+crossdir dire/dire -> File exists
+crossdir dire/tree -> File exists
+crossdir tree/none -> none/tree.
+crossdir tree/regu -> File exists
+crossdir tree/symb -> File exists
+crossdir tree/dire -> File exists
+crossdir tree/tree -> File exists
diff --git a/tests/generic/group b/tests/generic/group
index 26e584b..37697d8 100644
--- a/tests/generic/group
+++ b/tests/generic/group
@@ -137,3 +137,4 @@
 321 auto quick metadata log
 322 auto quick metadata log
 323 auto quick
+324 auto quick
-- 
1.8.1.4

<Prev in Thread] Current Thread [Next in Thread>